Safe Haskell | Safe-Inferred

Minimal

Description

This tests the new MINIMAL pragma present in GHC 7.8

# Documentation

class Foo a where

Minimal complete definition

foo, bar | bar, bat | foo, bat | fooBarBat

Methods

foo, bat, bar :: a

Any two of these are required...

fooBarBat :: (a, a, a)

.. or just this

class Weird a where

Minimal complete definition

a, b, c | d | e, (f | g)

Methods

a, g, f, e, d, c, b :: a

class NoMins a where

Minimal complete definition

x, y

Methods

x, z, y :: a

class FullMin a where

Methods

aaa, bbb :: a

class PartialMin a where

Minimal complete definition

ccc, ddd

Methods

ccc :: a

class EmptyMin a where

Minimal complete definition

Nothing

Methods

eee, fff :: a